/****************************************************************/
/*								*/
/* HYST ; stellt Hysterese fr Positionierung			*/
/* PIC-Rotorcontroller ein					*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include <dos.h>
#include <alloc.h>
#include <time.h>

#define RBR 0x00	/* Empfangsregister		*/
#define DLL 0x00	/* Baudrate (LS) DLAB = 1	*/
#define IER 0x01	/* Interrupt enable DLAB = 0	*/
#define DLM 0x01	/* Baudrate (MS) DLAB = 1	*/
#define LCR 0x03	/* Leitungskontrollregister	*/
#define MCR 0x04	/* Modemkontrollregister	*/
#define LSR 0x05	/* Linestatusregister		*/
#define baudpar 0x03    /* 8 bit,no parity,1 stop	*/
#define bitrate 19200

/* fr serielles I/O*/
int divisor=115200/bitrate,comp,com=0;
int comarr[4] = { 0x03f8,0x02f8,0x03e8,0x02e8 };

void serinit()
{
comp = comarr[com]; 		/* port number 0=com1 */
/* outportb((comp+IER), 0x00);	/* disable interrupts */
outportb((comp+LCR), 0x80);	/* DLAB=1*/
outportb((comp+DLL), (unsigned char) (divisor & 0x00ff)); /*low byte*/
outportb((comp+DLM), (unsigned char) (divisor & 0xff00) >> 8 );/*high byte*/
outportb((comp+LCR), baudpar);
outportb((comp+MCR), 0x03);	/*DTR,RTS*/
delay(10);
}

void lcddrv(prefix,x,laenge)
char *x,*prefix;
{
int n;

	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb((comp+RBR), prefix[0]);
	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb((comp+RBR), prefix[1]);
	for (n = 0; n < laenge; n++)
	{
	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb( (comp+RBR), x[n] );
	}
}


/* Hauptprogramm */
void main()
{
int status;
int hyst=0,hystlo=0;
char stringser[16],stringlo[2];
char *punkt=".";
time_t t;

time(&t);
printf("\nHeute ist: %s\n", ctime(&t));

if ( _argc <=1 ) printf("Aufruf: HYST <hyst> <com>\n");


com=0;
if ( _argc > 2 ) com=abs(atoi( _argv[2]))-1;

while ( (com < 0) | (com > 3) )
	{
	printf ( "falsche COM-Port Nummer (1-4)");
	printf("\nInput COM-port (1-4):");
	gets(stringser);
	com= abs(atoi(stringser))-1;
	}
	printf ( "benutztes Port: COM%d\n",com+1 );

/*setup serial i/o*/
serinit();

lcddrv("M:"," Hystrs_Cntrl;",14); /* */
delay(500); /* */

/* get input data via commandline or via stdin */
if ( _argc >1 )
	{
	hyst = atoi( _argv[1]);
	}
	else
	{
	printf("\nInput Hysterese-Winkel (3 Digits ; zehntel Grad !!):");
	gets(stringser);
	hyst= abs(atoi(stringser));
	}
printf("Hysterese (zehntel Grad) = %d\n", hyst);
hystlo=hyst%10;
hyst=hyst/10;

itoa(hyst,stringser,10); /**/
itoa(hystlo,stringlo,10);
strcat(stringser,punkt);
strcat(stringser,stringlo);
lcddrv("Yh",stringser,strlen(stringser)); /* */
strcat(stringser,";");
delay(500); /* */
lcddrv("K","",1); /* */

}
